# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501


class IdType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'local': 'bool',
        'id_part': 'str',
        'resource_type': 'str',
        'value_as_string': 'str',
        'version_id_part': 'str',
        'id_part_as_big_decimal': 'float',
        'urn': 'bool',
        'version_id_part_as_long': 'int',
        'base_url': 'str',
        'id_part_as_long': 'int',
        'id_part_valid': 'bool',
        'id_part_valid_long': 'bool',
        'version_id_part_valid_long': 'bool',
        'empty': 'bool',
        'value': 'str',
        'absolute': 'bool',
        'primitive': 'bool',
        'id_element': 'StringType',
        'extension_first_rep': 'Extension',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'local': 'local',
        'id_part': 'idPart',
        'resource_type': 'resourceType',
        'value_as_string': 'valueAsString',
        'version_id_part': 'versionIdPart',
        'id_part_as_big_decimal': 'idPartAsBigDecimal',
        'urn': 'urn',
        'version_id_part_as_long': 'versionIdPartAsLong',
        'base_url': 'baseUrl',
        'id_part_as_long': 'idPartAsLong',
        'id_part_valid': 'idPartValid',
        'id_part_valid_long': 'idPartValidLong',
        'version_id_part_valid_long': 'versionIdPartValidLong',
        'empty': 'empty',
        'value': 'value',
        'absolute': 'absolute',
        'primitive': 'primitive',
        'id_element': 'idElement',
        'extension_first_rep': 'extensionFirstRep',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, local=None, id_part=None, resource_type=None, value_as_string=None, version_id_part=None, id_part_as_big_decimal=None, urn=None, version_id_part_as_long=None, base_url=None, id_part_as_long=None, id_part_valid=None, id_part_valid_long=None, version_id_part_valid_long=None, empty=None, value=None, absolute=None, primitive=None, id_element=None, extension_first_rep=None, id_base=None, resource=None, boolean_primitive=None, date_time=None):  # noqa: E501
        """IdType - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._local = None
        self._id_part = None
        self._resource_type = None
        self._value_as_string = None
        self._version_id_part = None
        self._id_part_as_big_decimal = None
        self._urn = None
        self._version_id_part_as_long = None
        self._base_url = None
        self._id_part_as_long = None
        self._id_part_valid = None
        self._id_part_valid_long = None
        self._version_id_part_valid_long = None
        self._empty = None
        self._value = None
        self._absolute = None
        self._primitive = None
        self._id_element = None
        self._extension_first_rep = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if local is not None:
            self.local = local
        if id_part is not None:
            self.id_part = id_part
        if resource_type is not None:
            self.resource_type = resource_type
        if value_as_string is not None:
            self.value_as_string = value_as_string
        if version_id_part is not None:
            self.version_id_part = version_id_part
        if id_part_as_big_decimal is not None:
            self.id_part_as_big_decimal = id_part_as_big_decimal
        if urn is not None:
            self.urn = urn
        if version_id_part_as_long is not None:
            self.version_id_part_as_long = version_id_part_as_long
        if base_url is not None:
            self.base_url = base_url
        if id_part_as_long is not None:
            self.id_part_as_long = id_part_as_long
        if id_part_valid is not None:
            self.id_part_valid = id_part_valid
        if id_part_valid_long is not None:
            self.id_part_valid_long = id_part_valid_long
        if version_id_part_valid_long is not None:
            self.version_id_part_valid_long = version_id_part_valid_long
        if empty is not None:
            self.empty = empty
        if value is not None:
            self.value = value
        if absolute is not None:
            self.absolute = absolute
        if primitive is not None:
            self.primitive = primitive
        if id_element is not None:
            self.id_element = id_element
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this IdType.  # noqa: E501


        :return: The format_comments_pre of this IdType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this IdType.


        :param format_comments_pre: The format_comments_pre of this IdType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this IdType.  # noqa: E501


        :return: The format_comments_post of this IdType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this IdType.


        :param format_comments_post: The format_comments_post of this IdType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this IdType.  # noqa: E501


        :return: The id of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IdType.


        :param id: The id of this IdType.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this IdType.  # noqa: E501


        :return: The extension of this IdType.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this IdType.


        :param extension: The extension of this IdType.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this IdType.  # noqa: E501


        :return: The disallow_extensions of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this IdType.


        :param disallow_extensions: The disallow_extensions of this IdType.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def local(self):
        """Gets the local of this IdType.  # noqa: E501


        :return: The local of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._local

    @local.setter
    def local(self, local):
        """Sets the local of this IdType.


        :param local: The local of this IdType.  # noqa: E501
        :type: bool
        """

        self._local = local

    @property
    def id_part(self):
        """Gets the id_part of this IdType.  # noqa: E501


        :return: The id_part of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._id_part

    @id_part.setter
    def id_part(self, id_part):
        """Sets the id_part of this IdType.


        :param id_part: The id_part of this IdType.  # noqa: E501
        :type: str
        """

        self._id_part = id_part

    @property
    def resource_type(self):
        """Gets the resource_type of this IdType.  # noqa: E501


        :return: The resource_type of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this IdType.


        :param resource_type: The resource_type of this IdType.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def value_as_string(self):
        """Gets the value_as_string of this IdType.  # noqa: E501


        :return: The value_as_string of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._value_as_string

    @value_as_string.setter
    def value_as_string(self, value_as_string):
        """Sets the value_as_string of this IdType.


        :param value_as_string: The value_as_string of this IdType.  # noqa: E501
        :type: str
        """

        self._value_as_string = value_as_string

    @property
    def version_id_part(self):
        """Gets the version_id_part of this IdType.  # noqa: E501


        :return: The version_id_part of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._version_id_part

    @version_id_part.setter
    def version_id_part(self, version_id_part):
        """Sets the version_id_part of this IdType.


        :param version_id_part: The version_id_part of this IdType.  # noqa: E501
        :type: str
        """

        self._version_id_part = version_id_part

    @property
    def id_part_as_big_decimal(self):
        """Gets the id_part_as_big_decimal of this IdType.  # noqa: E501


        :return: The id_part_as_big_decimal of this IdType.  # noqa: E501
        :rtype: float
        """
        return self._id_part_as_big_decimal

    @id_part_as_big_decimal.setter
    def id_part_as_big_decimal(self, id_part_as_big_decimal):
        """Sets the id_part_as_big_decimal of this IdType.


        :param id_part_as_big_decimal: The id_part_as_big_decimal of this IdType.  # noqa: E501
        :type: float
        """

        self._id_part_as_big_decimal = id_part_as_big_decimal

    @property
    def urn(self):
        """Gets the urn of this IdType.  # noqa: E501


        :return: The urn of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._urn

    @urn.setter
    def urn(self, urn):
        """Sets the urn of this IdType.


        :param urn: The urn of this IdType.  # noqa: E501
        :type: bool
        """

        self._urn = urn

    @property
    def version_id_part_as_long(self):
        """Gets the version_id_part_as_long of this IdType.  # noqa: E501


        :return: The version_id_part_as_long of this IdType.  # noqa: E501
        :rtype: int
        """
        return self._version_id_part_as_long

    @version_id_part_as_long.setter
    def version_id_part_as_long(self, version_id_part_as_long):
        """Sets the version_id_part_as_long of this IdType.


        :param version_id_part_as_long: The version_id_part_as_long of this IdType.  # noqa: E501
        :type: int
        """

        self._version_id_part_as_long = version_id_part_as_long

    @property
    def base_url(self):
        """Gets the base_url of this IdType.  # noqa: E501


        :return: The base_url of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._base_url

    @base_url.setter
    def base_url(self, base_url):
        """Sets the base_url of this IdType.


        :param base_url: The base_url of this IdType.  # noqa: E501
        :type: str
        """

        self._base_url = base_url

    @property
    def id_part_as_long(self):
        """Gets the id_part_as_long of this IdType.  # noqa: E501


        :return: The id_part_as_long of this IdType.  # noqa: E501
        :rtype: int
        """
        return self._id_part_as_long

    @id_part_as_long.setter
    def id_part_as_long(self, id_part_as_long):
        """Sets the id_part_as_long of this IdType.


        :param id_part_as_long: The id_part_as_long of this IdType.  # noqa: E501
        :type: int
        """

        self._id_part_as_long = id_part_as_long

    @property
    def id_part_valid(self):
        """Gets the id_part_valid of this IdType.  # noqa: E501


        :return: The id_part_valid of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._id_part_valid

    @id_part_valid.setter
    def id_part_valid(self, id_part_valid):
        """Sets the id_part_valid of this IdType.


        :param id_part_valid: The id_part_valid of this IdType.  # noqa: E501
        :type: bool
        """

        self._id_part_valid = id_part_valid

    @property
    def id_part_valid_long(self):
        """Gets the id_part_valid_long of this IdType.  # noqa: E501


        :return: The id_part_valid_long of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._id_part_valid_long

    @id_part_valid_long.setter
    def id_part_valid_long(self, id_part_valid_long):
        """Sets the id_part_valid_long of this IdType.


        :param id_part_valid_long: The id_part_valid_long of this IdType.  # noqa: E501
        :type: bool
        """

        self._id_part_valid_long = id_part_valid_long

    @property
    def version_id_part_valid_long(self):
        """Gets the version_id_part_valid_long of this IdType.  # noqa: E501


        :return: The version_id_part_valid_long of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._version_id_part_valid_long

    @version_id_part_valid_long.setter
    def version_id_part_valid_long(self, version_id_part_valid_long):
        """Sets the version_id_part_valid_long of this IdType.


        :param version_id_part_valid_long: The version_id_part_valid_long of this IdType.  # noqa: E501
        :type: bool
        """

        self._version_id_part_valid_long = version_id_part_valid_long

    @property
    def empty(self):
        """Gets the empty of this IdType.  # noqa: E501


        :return: The empty of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this IdType.


        :param empty: The empty of this IdType.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def value(self):
        """Gets the value of this IdType.  # noqa: E501


        :return: The value of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this IdType.


        :param value: The value of this IdType.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def absolute(self):
        """Gets the absolute of this IdType.  # noqa: E501


        :return: The absolute of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._absolute

    @absolute.setter
    def absolute(self, absolute):
        """Sets the absolute of this IdType.


        :param absolute: The absolute of this IdType.  # noqa: E501
        :type: bool
        """

        self._absolute = absolute

    @property
    def primitive(self):
        """Gets the primitive of this IdType.  # noqa: E501


        :return: The primitive of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this IdType.


        :param primitive: The primitive of this IdType.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def id_element(self):
        """Gets the id_element of this IdType.  # noqa: E501


        :return: The id_element of this IdType.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this IdType.


        :param id_element: The id_element of this IdType.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this IdType.  # noqa: E501


        :return: The extension_first_rep of this IdType.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this IdType.


        :param extension_first_rep: The extension_first_rep of this IdType.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_base(self):
        """Gets the id_base of this IdType.  # noqa: E501


        :return: The id_base of this IdType.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this IdType.


        :param id_base: The id_base of this IdType.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this IdType.  # noqa: E501


        :return: The resource of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this IdType.


        :param resource: The resource of this IdType.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this IdType.  # noqa: E501


        :return: The boolean_primitive of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this IdType.


        :param boolean_primitive: The boolean_primitive of this IdType.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this IdType.  # noqa: E501


        :return: The date_time of this IdType.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this IdType.


        :param date_time: The date_time of this IdType.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IdType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
